public class LinkedList{
    Node start;   
    
    public LinkedList(){
        // this initializes an empty linked list
       this.start = null;   
    }
    
    public void insertAtBeginning( Node newNode){
        // Make the new node point the the first 
        // element in the list
        newNode.next = this.start;
        // replace the old beginning of the list
        this.start = newNode;
    }
    
    public void insertAtEnd( Node newNode ){
        Node pointer = this.start;
        // we want to reach the end of the list
        while ( pointer.next != null){
            pointer = pointer.next;
        }
        // when we finish this loop
        // we will have the last element of the
        // list in the pointer Node
        
        pointer.next = newNode;
        // ensure that the next pointer of 
        // the last element points to nowhere
        newNode.next = null;
    }
         
    // this method will insert a new node,
    // in ascending order
    public void insertAfter( Node newNode ){
        Node pointer = this.start;
        int value = newNode.data;
        
        // we want to insert the new element
        // if value >= pointer.data && value <= pointer.next.data
        while ( pointer != null && // this is for an empty list
                pointer.next != null && // this is when we reach the end 
                pointer.next.data <= value ){
            pointer = pointer.next;
        }
        
        // if this is an empty list
        if ( pointer == null ){
             this.start = newNode;   
        }
        // if the list is not empty
        else {
             // Connect the next pointer of the newNode
             // to the correct element in the list
             newNode.next = pointer.next;
                 
             // make thhe list copntaint the newNode
             pointer.next = newNode;   
        }
    }
    
    public void remove( int value){
        Node pointer = this.start;
        // This will be the previous element in the list
        Node prev = null;
        
        if ( this.start == null ){
            // stop executing this method right here
            return;   
        }
        
        // we need to stop when we find the element to remove
        while ( pointer != null){
            if ( pointer.data == value){
                // break the loop if we found the value
                // in the list
                 break;
            }
            // move to the next element in the list
            prev = pointer;
            pointer = pointer.next;
        }
        
        // this means we found the element in our list
        if ( pointer != null ){
            // check if we are rempoveing the first element
            if ( prev == null){
                this.start = this.start.next;
            }
            else {
                // make the previous element 
                // point to the next one
                prev.next = pointer.next;
                // disconnect the element we want to remove
                pointer.next = null;
            }
        }
    }
   
    public String toString(){
        String str = "";
        // this will have a reference to some 
        // element in the list
        Node pointer = this.start;
        
        // if this is an empty linkedlist
        // then we return the empty string
        if ( pointer == null ){
            return str;   
        }
        // append the result of toString of the first 
        // element in the list
        str += pointer.toString();
        
        // until we reach the last element of the array
        while ( pointer.next != null ) {
            // have pointer POINT to the next element
            // in the list
            pointer = pointer.next;
            str += pointer.toString();
        }
        
        return str;
    }
}